// Room.h: interface for the Room class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ROOM_H__70E52889_A5CF_4B34_B9D2_F52E79A5B906__INCLUDED_)
#define AFX_ROOM_H__70E52889_A5CF_4B34_B9D2_F52E79A5B906__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


// disable long warnings for +255 char strings.

#pragma warning(disable:4786) 

#include <vector>
#include "circleFile.h"
#include "Ex_Desc_Data.h"
#include "Room_Dir_Data.h"
#include "Zone_Cmd_Data.h"

using namespace std;
const int NUM_OF_DIRS = 9;

class Room  
{
public:
	void SwitchZcmds(int from, int to);
	int add_zcmd(Zone_Cmd_Data *);
	void add_exdata(string  keywords, string  desc);
	int load_room(CircleFile *cf);
	bool write_room(CircleFile *cfile);
	bool delete_exdata(string x);
	bool delete_exdata(int x);
	Ex_Desc_Data *get_exdata(string x);
	int get_num_exdata();
	Ex_Desc_Data * get_exdata(int x);

	Room();
	virtual ~Room();


	int number;
	int room_flags;
	Room_Dir_Data direction_data[NUM_OF_DIRS];
	string description;
	string name;
	int sector_type;
	int zone;

	vector<Ex_Desc_Data> exdesc;
	vector<Zone_Cmd_Data> zonecmd;

private:
	int ascii2bitvector(const char *input);
	void bitvector2ascii(char *output);
};

#endif // !defined(AFX_ROOM_H__70E52889_A5CF_4B34_B9D2_F52E79A5B906__INCLUDED_)
