/*
		Zone_Data.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.
.		
		Data member type, includes load/save/etc functions.
*/

#pragma warning(disable:4786)
#include "stdafx.h"
#include "utils.h"
#include "Cbreak.h"
#include "Zone_Data.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

extern CDirDialog ourlib;
extern World the_world;

Zone_Data::Zone_Data()
{

}

Zone_Data::~Zone_Data()
{

}

int Zone_Data::load_zone(int zone_num)
{
  CircleFile fp;
  string temp;

  temp = iprintf("%s\\zon\\%d.zon",ourlib.m_strPath,zone_num);
  fp.open_file(temp, 0, zone_num);
  
  fp.get_line(&temp);  /* this is just #%d .. ignore */
  fp.tilde_read(&temp);  /* zone name */
  name = temp;
  number = zone_num;
  fp.get_line(&temp);  /* top, life, reset */
  top = atoi(temp.substr(0,temp.find(" ")).c_str());
  lifespan = atoi(temp.substr(temp.find(" ") + 1, temp.rfind(" ")-1).c_str());
  reset_mode = atoi(temp.substr(temp.rfind(" ")+1,temp.size()).c_str());
  fp.close_file();
 
  return true;
}

bool Zone_Data::load_zonecmds()
{
  CircleFile fp;
  string temp,temp2;
  int cur_room=-1;
	Zone_Cmd_Data *new_zcmd;

  //if(number < 0) {
//	return FALSE;
 // }
  temp = iprintf("%s\\zon\\%d.zon",ourlib.m_strPath,number);
  fp.open_file(temp, 0, number);
  fp.get_line(&temp);  /* this is just #%d .. ignore */
  fp.tilde_read(&temp);  /* zone name */
  fp.get_line(&temp);  /* top, life, reset */

  /* now, the nitty gritty */
  fp.get_line(&temp);
	while(!fp.eof() && (!temp.empty() &&temp.at(0) != 'S')) {
		if(temp.at(0) == '*') {
			fp.get_line(&temp);
			continue;
		}
    new_zcmd = new Zone_Cmd_Data;
    new_zcmd->cmd = temp.at(0);
		/* now we break up the commands */
    temp = temp.substr(temp.find(" ")+1);
  	temp2=temp.substr(0,temp.find(" ")); 
  	new_zcmd->depend=atoi(temp2.c_str());
  
    temp = temp.substr(temp.find(" ")+1);
  	temp2=temp.substr(0,temp.find(" ")); 
  	new_zcmd->arg[0]=atoi(temp2.c_str());

    temp = temp.substr(temp.find(" ")+1);
  	temp2=temp.substr(0,temp.find(" "));
  	new_zcmd->arg[1]=atoi(temp2.c_str());
    
	  if(new_zcmd->cmd != 'G' && new_zcmd->cmd != 'R') {
  	  temp = temp.substr(temp.find(" ")+1);
    	temp2=temp.substr(0,temp.find(" "));
    	new_zcmd->arg[2]=atoi(temp2.c_str());
		}
    
		/* now figure out which room it belongs to */
		if(new_zcmd->cmd == 'M' || new_zcmd->cmd == 'O') {
			cur_room= new_zcmd->arg[2];
		} else if (new_zcmd->cmd == 'D' || new_zcmd->cmd == 'R') {
			cur_room= new_zcmd->arg[0];
		}
		
		/* now, put it in that room, if it exists */
		if(the_world.room_list.find(cur_room) == the_world.room_list.end()) {
			TRACE0(iprintf("Error: zone %d had commands allocated for nonexistant room %d\n",
					number,cur_room));
			delete new_zcmd;
		} else {
		  the_world.room_list[cur_room].add_zcmd(new_zcmd);
		}
		fp.get_line(&temp);
	}
	return TRUE;
}



void Zone_Data::write_zone(CircleFile *cf)
{
  string obuf;
  string temp;
  map<int,Room>::const_iterator ri;
  vector<Zone_Cmd_Data>::const_iterator zi;

  obuf = iprintf("#%d\n",number);
  obuf += iprintf("%s~\n",name.c_str());
  obuf += iprintf("%d %d %d\n",top,lifespan,reset_mode);

  for(ri=the_world.room_list.begin();ri!=the_world.room_list.end();ri++) {
		if(ri->second.zone == number) {
			for(zi = ri->second.zonecmd.begin();zi!= ri->second.zonecmd.end();zi++) {
				switch(zi->cmd) {
				  case 'G':
          case 'R':
						obuf += iprintf("%c %d %d %d\n",zi->cmd,zi->depend,zi->arg[0],zi->arg[1]);
						break;
					default:
						obuf += iprintf("%c %d %d %d %d\n",zi->cmd,zi->depend,zi->arg[0],zi->arg[1],zi->arg[2]);
						break;
				}
			}
		}
  }
	obuf += "S\n";
	cf->write_line(&obuf); 
}
